package at.jku.ssw.queue.test;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

import at.jku.ssw.queue.Queue;
import at.jku.students.queue.ArrayQueue;

public class ArrayQueueTest extends QueueTest {

	@Override
	protected Queue createQueue() {
		return new ArrayQueue();
	}

	@Test
	public void testPushOverflow() {
		Queue queue = createQueue();
		for (int i = 0; i < ArrayQueue.MAX_SIZE; i++) {
			queue.push(i);
		}
		thrown.expect(IllegalStateException.class);
		queue.push(42);
	}

	@Test
	public void testPushOverflowInsert() {
		Queue queue = createQueue();
		for (int i = 0; i < ArrayQueue.MAX_SIZE - 1; i++) {
			queue.push(i);
			assertEquals(i, queue.take());

		}
		queue.push(1);
		queue.push(5);
		queue.push(7);
		assertEquals(3, queue.size());
		assertEquals(1, queue.take());
		assertEquals(5, queue.take());
		assertEquals(7, queue.take());
		assertEquals(0, queue.size());
	}

	@Test
	public void testPushOverflowPeakLast() {
		Queue queue = createQueue();
		for (int i = 0; i < ArrayQueue.MAX_SIZE - 1; i++) {
			queue.push(i);
			assertEquals(i, queue.take());

		}
		queue.push(1);
		assertEquals(1, queue.size());
		assertEquals(1, queue.peekLast());
	}
}
